import React from 'react';
import { Async } from 'react-async-await';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var Context = React.createContext({
  promise: undefined,
  startLoading: function startLoading() {}
});

var Loading = function (_React$Component) {
  inherits(Loading, _React$Component);

  function Loading() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, Loading);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = Loading.__proto__ || Object.getPrototypeOf(Loading)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      promise: undefined,
      startLoading: function startLoading(promise) {
        _this.setState(function (state) {
          if (state.promise === promise) return null;
          return { promise: promise };
        });
      }
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(Loading, [{
    key: "render",
    value: function render() {
      return React.createElement(
        Context.Provider,
        { value: this.state },
        React.createElement(
          Async,
          {
            "await": this.state.promise,
            waiting: function waiting() {
              return true;
            },
            then: function then() {
              return false;
            },
            "catch": function _catch() {
              return false;
            }
          },
          this.props.children
        )
      );
    }
  }]);
  return Loading;
}(React.Component);

function createResource(load, resolve) {
  var cache = new Map();

  function memoizedLoad(props) {
    var key = resolve(props);
    if (!cache.has(key)) cache.set(key, load(props));
    return cache.get(key);
  }

  var LoadingResource = function (_React$Component) {
    inherits(LoadingResource, _React$Component);

    function LoadingResource() {
      classCallCheck(this, LoadingResource);
      return possibleConstructorReturn(this, (LoadingResource.__proto__ || Object.getPrototypeOf(LoadingResource)).apply(this, arguments));
    }

    createClass(LoadingResource, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.props.startLoading(this.props.resource.promise);
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        this.componentDidMount();
      }
    }, {
      key: "render",
      value: function render() {
        return null;
      }
    }], [{
      key: "displayName",
      get: function get$$1() {
        return "Loading(" + (Resource.displayName || Resource.name || "Resource") + ")";
      }
    }]);
    return LoadingResource;
  }(React.Component);

  function Resource(props) {
    return React.createElement(
      Async,
      {
        "await": memoizedLoad(props),
        waiting: function waiting(promise) {
          return { status: 0, promise: promise };
        },
        then: function then(value) {
          return { status: 1, value: value };
        },
        "catch": function _catch(error) {
          return { status: 2, error: error };
        }
      },
      function (resource) {
        switch (resource.status) {
          case 0:
            return React.createElement(
              Context.Consumer,
              null,
              function (context) {
                return React.createElement(LoadingResource, {
                  startLoading: context.startLoading,
                  resource: resource
                });
              }
            );
          case 1:
            return props.children(resource.value);
          case 2:
          default:
            cache.delete(resolve(props));
            throw resource.error;
        }
      }
    );
  }

  return Resource;
}

export { createResource, Loading };
