import React from "react";
import { Async } from "react-async-await";

export const Context = React.createContext({
  promise: undefined,
  startLoading() {}
});

export default class Loading extends React.Component {
  state = {
    promise: undefined,
    startLoading: promise => {
      this.setState(state => {
        if (state.promise === promise) return null;
        return { promise };
      });
    }
  };

  render() {
    return (
      <Context.Provider value={this.state}>
        <Async
          await={this.state.promise}
          waiting={() => true}
          then={() => false}
          catch={() => false}
        >
          {this.props.children}
        </Async>
      </Context.Provider>
    );
  }
}
